﻿namespace CovarianceAndContravariance
{
    public sealed class Rental<TVehicle> where TVehicle : IVehicle
    {
        private readonly ICalculator<TVehicle> rentalCalculator;

        public Rental(ICalculator<TVehicle> rentalCalculator)
        {
            this.rentalCalculator = rentalCalculator;
        }

        public void RentVehicle(TVehicle vehicle, int days, int driversAge)
        {
            var rentalPrice = rentalCalculator.CalculateRentalPrice(vehicle, days, driversAge);
            Console.WriteLine($"Please pay {rentalPrice} CZK at cash desk in order to rent this vehicle.");
        }
    }
}
