﻿namespace CovarianceAndContravariance
{
    public class Solution
    {
        public static void TestSolution()
        {
            var calculator = new RentalCalculator();

            var carRental = new Rental<Car>(calculator);
            carRental.RentVehicle(new Car(true), 1, 25);
            carRental.RentVehicle(new Car(false), 2, 21);

            var motorbikeRental = new Rental<Motorbike>(calculator);
            motorbikeRental.RentVehicle(new Motorbike(), 3, 18);
            Console.ReadKey();
        }
    }

    public interface ICalculator<in TVehicle>
    {
        decimal CalculateRentalPrice(TVehicle vehicle, int days, int driversAge);
    }

    public class RentalCalculator : ICalculator<IVehicle>
    {
        public decimal CalculateRentalPrice(IVehicle vehicle, int days, int driversAge)
        {
            var baseRentalPrice = vehicle.GetVehicleValue() * days;
            return driversAge >= 24 && driversAge <= 80 ? baseRentalPrice : baseRentalPrice * 1.2m;
        }
    }
}
