﻿namespace Exceptions_04
{
    /// <summary>
    /// All credit goes to David Kadlec, author of this demo sample
    /// </summary>
    class Program
    {
        static void Main(string[] args)
        {
            ExceptionDemo();
        }

        public static void ExceptionDemo()
        {
            string myMessage = "... catched.";

            try
            {
                DynamitMethod();
                Console.WriteLine("toto se neprovede");
            }
            catch (DynamiteException exc)
            {
                Console.WriteLine(exc.Message + myMessage);
            }
            catch (Exception exc) //when (exc is FormatException || exc is OverflowException)
            {
                Console.WriteLine(exc.Message + myMessage);

                // reset callstacku - ztratim informaci o tom, kde k vyjimce doslo
                //throw exc;

                // zachova callstack
                //throw;

                // zachova callstack zaobalenim do nove vyjimky
                //throw new Exception("new exception", exc);
            }
            finally //provede se vzdy, i kdyz k vyjimce nedojde
            {
                Console.WriteLine("Finally");
                //Console.ReadKey();
                // uvolneni zdroju, ...
            }


            // Nove lze v C# 7.0 vyhodit vyjimku v ramci vyrazu
            var time = "10:08".Split(':');
            var hours = time.Length == 2 ? time[0] : throw new InvalidOperationException("Invalid time format!");
        }

        public static void DynamitMethod()
        {
            //vyhodit vlastni vyjimku
            //throw new DynamiteException("my dynamit exception", 20);

            // Vyhodime invalid operation
            throw new InvalidOperationException("Invalid operation");
        }

        //bezne tridy vyjimek:
        // - Exception - doporucena MS pro vase vlastni vyjimky
        // - DivideByZeroException
        // - InvalidCastException
        // - InvalidOperationException
        // - ArgumentException
        // - ArgumentOutOfRangeException
    }
}
