﻿namespace Generics_05
{
    /// <summary>
    /// Based on Lukas Daubner demo sample
    /// </summary>
    class Program
    {
        static void Main(string[] args)
        {
            //Reseni samostatne prace (zadani viz nize)
            //Solution.SwapUtilTest();
            //Solution.CollectionUtilTest();

            //Konstruktor generické třídy, datový typ je specifikován.
            var gen = new MyGenClass<string>(new[]
            {
                "Why do Java Programmers wear glasses?",
                "Because they don't C#",
                "Are you saying they're Visually Basic?"
            });

            //Volání indexeru
            for (int i = 0; i < gen.GetLength(); i++)
            {
                Console.WriteLine(gen[i]);
            }

            Console.ReadKey(true);
        }
    }


    /// <summary>
    /// Generická třída parametrizovana typem T, ktery musi byt trida
    /// Dalsi mozna omezeni, viz:
    /// https://msdn.microsoft.com/en-us/library/d5x73970.aspx?f=255&MSPPError=-2147217396
    /// </summary>
    /// <typeparam name="T"></typeparam>
    class MyGenClass<T> where T : class
    {
        readonly List<T> list;

        public MyGenClass(T[] values)
        {
            list = new List<T>();
            for (int i = 0; i <= values.GetUpperBound(0); i++)
            {
                list.Add(values[i]);
            }
        }

        public int GetLength()
        {
            return this.list.Count;
        }

        /// <summary>
        /// Generic indexer written in expression
        /// bodied function notation
        /// </summary>
        /// <param name="i">
        /// index of value of type T to retrieve
        /// </param>
        /// <returns></returns>
        public T this[int i] => list[i];
    }

    /// <summary>
    /// Ukol:
    /// 
    /// I. ve tride SwapUtils vytvorte dve
    /// pretizene metody: Swap(...) 
    /// prvni z nich bude slouzit k zamene
    /// dvou integeru, druha pak vzajemne 
    /// vymeni dva stringy
    /// 
    /// II. do tridy SwapUtils pridejte 
    /// generickou metodu GenericSwap(...)
    /// ktera zameni 2 promene
    /// </summary>
}
