﻿using IDisposable_00;

namespace IDisposable
{
    class Program
    {
        static async Task Main(string[] args)
        {
            //await PrintRandomCatFact_ManualDispose();
            await PrintRandomCatFact_Using();
        }

        static async Task PrintRandomCatFact_ManualDispose()
        {
            var client = new CatApiClient();

            var catFact = await client.GetRandomCatFact();
            Console.WriteLine(catFact.Fact);

            client.Dispose();
        }

        static async Task PrintRandomCatFact_Using()
        {
            using (var client = new CatApiClient())
            {
                var catFact = await client.GetRandomCatFact();
                Console.WriteLine(catFact.Fact);
            }
        }
    }
}
